/*eslint-disable block-scoped-var, id-length, no-control-regex, no-magic-numbers, no-prototype-builtins, no-redeclare, no-shadow, no-var, sort-vars*/
"use strict";
var $protobuf = require("protobufjs/minimal");
// Common aliases
var $Reader = $protobuf.Reader, $Writer = $protobuf.Writer, $util = $protobuf.util;
// Exported root namespace
var $root = $protobuf.roots.qr_code_data || ($protobuf.roots.qr_code_data = {});
$root.vereign = (function () {
    /**
     * Namespace vereign.
     * @exports vereign
     * @namespace
     */
    var vereign = {};
    vereign.protobuf = (function () {
        /**
         * Namespace protobuf.
         * @memberof vereign
         * @namespace
         */
        var protobuf = {};
        protobuf.qrcode_data = (function () {
            /**
             * Namespace qrcode_data.
             * @memberof vereign.protobuf
             * @namespace
             */
            var qrcode_data = {};
            qrcode_data.Participant_V1 = (function () {
                /**
                 * Properties of a Participant_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @interface IParticipant_V1
                 * @property {string|null} [name] Participant_V1 name
                 * @property {string|null} [email] Participant_V1 email
                 */
                /**
                 * Constructs a new Participant_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @classdesc Represents a Participant_V1.
                 * @implements IParticipant_V1
                 * @constructor
                 * @param {vereign.protobuf.qrcode_data.IParticipant_V1=} [properties] Properties to set
                 */
                function Participant_V1(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
                /**
                 * Participant_V1 name.
                 * @member {string} name
                 * @memberof vereign.protobuf.qrcode_data.Participant_V1
                 * @instance
                 */
                Participant_V1.prototype.name = "";
                /**
                 * Participant_V1 email.
                 * @member {string} email
                 * @memberof vereign.protobuf.qrcode_data.Participant_V1
                 * @instance
                 */
                Participant_V1.prototype.email = "";
                /**
                 * Creates a new Participant_V1 instance using the specified properties.
                 * @function create
                 * @memberof vereign.protobuf.qrcode_data.Participant_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IParticipant_V1=} [properties] Properties to set
                 * @returns {vereign.protobuf.qrcode_data.Participant_V1} Participant_V1 instance
                 */
                Participant_V1.create = function create(properties) {
                    return new Participant_V1(properties);
                };
                /**
                 * Encodes the specified Participant_V1 message. Does not implicitly {@link vereign.protobuf.qrcode_data.Participant_V1.verify|verify} messages.
                 * @function encode
                 * @memberof vereign.protobuf.qrcode_data.Participant_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IParticipant_V1} message Participant_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Participant_V1.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/ 10).string(message.name);
                    if (message.email != null && Object.hasOwnProperty.call(message, "email"))
                        writer.uint32(/* id 2, wireType 2 =*/ 18).string(message.email);
                    return writer;
                };
                /**
                 * Encodes the specified Participant_V1 message, length delimited. Does not implicitly {@link vereign.protobuf.qrcode_data.Participant_V1.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.Participant_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IParticipant_V1} message Participant_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Participant_V1.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
                /**
                 * Decodes a Participant_V1 message from the specified reader or buffer.
                 * @function decode
                 * @memberof vereign.protobuf.qrcode_data.Participant_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {vereign.protobuf.qrcode_data.Participant_V1} Participant_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Participant_V1.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.vereign.protobuf.qrcode_data.Participant_V1();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                            case 1:
                                message.name = reader.string();
                                break;
                            case 2:
                                message.email = reader.string();
                                break;
                            default:
                                reader.skipType(tag & 7);
                                break;
                        }
                    }
                    return message;
                };
                /**
                 * Decodes a Participant_V1 message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.Participant_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {vereign.protobuf.qrcode_data.Participant_V1} Participant_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Participant_V1.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
                /**
                 * Verifies a Participant_V1 message.
                 * @function verify
                 * @memberof vereign.protobuf.qrcode_data.Participant_V1
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Participant_V1.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.email != null && message.hasOwnProperty("email"))
                        if (!$util.isString(message.email))
                            return "email: string expected";
                    return null;
                };
                /**
                 * Creates a Participant_V1 message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof vereign.protobuf.qrcode_data.Participant_V1
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {vereign.protobuf.qrcode_data.Participant_V1} Participant_V1
                 */
                Participant_V1.fromObject = function fromObject(object) {
                    if (object instanceof $root.vereign.protobuf.qrcode_data.Participant_V1)
                        return object;
                    var message = new $root.vereign.protobuf.qrcode_data.Participant_V1();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.email != null)
                        message.email = String(object.email);
                    return message;
                };
                /**
                 * Creates a plain object from a Participant_V1 message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof vereign.protobuf.qrcode_data.Participant_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.Participant_V1} message Participant_V1
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Participant_V1.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.name = "";
                        object.email = "";
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.email != null && message.hasOwnProperty("email"))
                        object.email = message.email;
                    return object;
                };
                /**
                 * Converts this Participant_V1 to JSON.
                 * @function toJSON
                 * @memberof vereign.protobuf.qrcode_data.Participant_V1
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Participant_V1.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
                return Participant_V1;
            })();
            qrcode_data.Attachment_V1 = (function () {
                /**
                 * Properties of an Attachment_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @interface IAttachment_V1
                 * @property {string|null} [name] Attachment_V1 name
                 * @property {string|null} [url] Attachment_V1 url
                 * @property {number|null} [size] Attachment_V1 size
                 * @property {string|null} [hashAlg] Attachment_V1 hashAlg
                 * @property {Uint8Array|null} [hash] Attachment_V1 hash
                 * @property {Uint8Array|null} [signature] Attachment_V1 signature
                 */
                /**
                 * Constructs a new Attachment_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @classdesc Represents an Attachment_V1.
                 * @implements IAttachment_V1
                 * @constructor
                 * @param {vereign.protobuf.qrcode_data.IAttachment_V1=} [properties] Properties to set
                 */
                function Attachment_V1(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
                /**
                 * Attachment_V1 name.
                 * @member {string} name
                 * @memberof vereign.protobuf.qrcode_data.Attachment_V1
                 * @instance
                 */
                Attachment_V1.prototype.name = "";
                /**
                 * Attachment_V1 url.
                 * @member {string} url
                 * @memberof vereign.protobuf.qrcode_data.Attachment_V1
                 * @instance
                 */
                Attachment_V1.prototype.url = "";
                /**
                 * Attachment_V1 size.
                 * @member {number} size
                 * @memberof vereign.protobuf.qrcode_data.Attachment_V1
                 * @instance
                 */
                Attachment_V1.prototype.size = 0;
                /**
                 * Attachment_V1 hashAlg.
                 * @member {string} hashAlg
                 * @memberof vereign.protobuf.qrcode_data.Attachment_V1
                 * @instance
                 */
                Attachment_V1.prototype.hashAlg = "";
                /**
                 * Attachment_V1 hash.
                 * @member {Uint8Array} hash
                 * @memberof vereign.protobuf.qrcode_data.Attachment_V1
                 * @instance
                 */
                Attachment_V1.prototype.hash = $util.newBuffer([]);
                /**
                 * Attachment_V1 signature.
                 * @member {Uint8Array} signature
                 * @memberof vereign.protobuf.qrcode_data.Attachment_V1
                 * @instance
                 */
                Attachment_V1.prototype.signature = $util.newBuffer([]);
                /**
                 * Creates a new Attachment_V1 instance using the specified properties.
                 * @function create
                 * @memberof vereign.protobuf.qrcode_data.Attachment_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IAttachment_V1=} [properties] Properties to set
                 * @returns {vereign.protobuf.qrcode_data.Attachment_V1} Attachment_V1 instance
                 */
                Attachment_V1.create = function create(properties) {
                    return new Attachment_V1(properties);
                };
                /**
                 * Encodes the specified Attachment_V1 message. Does not implicitly {@link vereign.protobuf.qrcode_data.Attachment_V1.verify|verify} messages.
                 * @function encode
                 * @memberof vereign.protobuf.qrcode_data.Attachment_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IAttachment_V1} message Attachment_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Attachment_V1.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/ 10).string(message.name);
                    if (message.url != null && Object.hasOwnProperty.call(message, "url"))
                        writer.uint32(/* id 2, wireType 2 =*/ 18).string(message.url);
                    if (message.size != null && Object.hasOwnProperty.call(message, "size"))
                        writer.uint32(/* id 3, wireType 0 =*/ 24).int32(message.size);
                    if (message.hash != null && Object.hasOwnProperty.call(message, "hash"))
                        writer.uint32(/* id 4, wireType 2 =*/ 34).bytes(message.hash);
                    if (message.hashAlg != null && Object.hasOwnProperty.call(message, "hashAlg"))
                        writer.uint32(/* id 5, wireType 2 =*/ 42).string(message.hashAlg);
                    if (message.signature != null && Object.hasOwnProperty.call(message, "signature"))
                        writer.uint32(/* id 6, wireType 2 =*/ 50).bytes(message.signature);
                    return writer;
                };
                /**
                 * Encodes the specified Attachment_V1 message, length delimited. Does not implicitly {@link vereign.protobuf.qrcode_data.Attachment_V1.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.Attachment_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IAttachment_V1} message Attachment_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Attachment_V1.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
                /**
                 * Decodes an Attachment_V1 message from the specified reader or buffer.
                 * @function decode
                 * @memberof vereign.protobuf.qrcode_data.Attachment_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {vereign.protobuf.qrcode_data.Attachment_V1} Attachment_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Attachment_V1.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.vereign.protobuf.qrcode_data.Attachment_V1();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                            case 1:
                                message.name = reader.string();
                                break;
                            case 2:
                                message.url = reader.string();
                                break;
                            case 3:
                                message.size = reader.int32();
                                break;
                            case 5:
                                message.hashAlg = reader.string();
                                break;
                            case 4:
                                message.hash = reader.bytes();
                                break;
                            case 6:
                                message.signature = reader.bytes();
                                break;
                            default:
                                reader.skipType(tag & 7);
                                break;
                        }
                    }
                    return message;
                };
                /**
                 * Decodes an Attachment_V1 message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.Attachment_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {vereign.protobuf.qrcode_data.Attachment_V1} Attachment_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Attachment_V1.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
                /**
                 * Verifies an Attachment_V1 message.
                 * @function verify
                 * @memberof vereign.protobuf.qrcode_data.Attachment_V1
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Attachment_V1.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.url != null && message.hasOwnProperty("url"))
                        if (!$util.isString(message.url))
                            return "url: string expected";
                    if (message.size != null && message.hasOwnProperty("size"))
                        if (!$util.isInteger(message.size))
                            return "size: integer expected";
                    if (message.hashAlg != null && message.hasOwnProperty("hashAlg"))
                        if (!$util.isString(message.hashAlg))
                            return "hashAlg: string expected";
                    if (message.hash != null && message.hasOwnProperty("hash"))
                        if (!(message.hash && typeof message.hash.length === "number" || $util.isString(message.hash)))
                            return "hash: buffer expected";
                    if (message.signature != null && message.hasOwnProperty("signature"))
                        if (!(message.signature && typeof message.signature.length === "number" || $util.isString(message.signature)))
                            return "signature: buffer expected";
                    return null;
                };
                /**
                 * Creates an Attachment_V1 message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof vereign.protobuf.qrcode_data.Attachment_V1
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {vereign.protobuf.qrcode_data.Attachment_V1} Attachment_V1
                 */
                Attachment_V1.fromObject = function fromObject(object) {
                    if (object instanceof $root.vereign.protobuf.qrcode_data.Attachment_V1)
                        return object;
                    var message = new $root.vereign.protobuf.qrcode_data.Attachment_V1();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.url != null)
                        message.url = String(object.url);
                    if (object.size != null)
                        message.size = object.size | 0;
                    if (object.hashAlg != null)
                        message.hashAlg = String(object.hashAlg);
                    if (object.hash != null)
                        if (typeof object.hash === "string")
                            $util.base64.decode(object.hash, message.hash = $util.newBuffer($util.base64.length(object.hash)), 0);
                        else if (object.hash.length)
                            message.hash = object.hash;
                    if (object.signature != null)
                        if (typeof object.signature === "string")
                            $util.base64.decode(object.signature, message.signature = $util.newBuffer($util.base64.length(object.signature)), 0);
                        else if (object.signature.length)
                            message.signature = object.signature;
                    return message;
                };
                /**
                 * Creates a plain object from an Attachment_V1 message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof vereign.protobuf.qrcode_data.Attachment_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.Attachment_V1} message Attachment_V1
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Attachment_V1.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.name = "";
                        object.url = "";
                        object.size = 0;
                        if (options.bytes === String)
                            object.hash = "";
                        else {
                            object.hash = [];
                            if (options.bytes !== Array)
                                object.hash = $util.newBuffer(object.hash);
                        }
                        object.hashAlg = "";
                        if (options.bytes === String)
                            object.signature = "";
                        else {
                            object.signature = [];
                            if (options.bytes !== Array)
                                object.signature = $util.newBuffer(object.signature);
                        }
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.url != null && message.hasOwnProperty("url"))
                        object.url = message.url;
                    if (message.size != null && message.hasOwnProperty("size"))
                        object.size = message.size;
                    if (message.hash != null && message.hasOwnProperty("hash"))
                        object.hash = options.bytes === String ? $util.base64.encode(message.hash, 0, message.hash.length) : options.bytes === Array ? Array.prototype.slice.call(message.hash) : message.hash;
                    if (message.hashAlg != null && message.hasOwnProperty("hashAlg"))
                        object.hashAlg = message.hashAlg;
                    if (message.signature != null && message.hasOwnProperty("signature"))
                        object.signature = options.bytes === String ? $util.base64.encode(message.signature, 0, message.signature.length) : options.bytes === Array ? Array.prototype.slice.call(message.signature) : message.signature;
                    return object;
                };
                /**
                 * Converts this Attachment_V1 to JSON.
                 * @function toJSON
                 * @memberof vereign.protobuf.qrcode_data.Attachment_V1
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Attachment_V1.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
                return Attachment_V1;
            })();
            qrcode_data.Recipients_V1 = (function () {
                /**
                 * Properties of a Recipients_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @interface IRecipients_V1
                 * @property {Array.<vereign.protobuf.qrcode_data.IParticipant_V1>|null} [to] Recipients_V1 to
                 * @property {Array.<vereign.protobuf.qrcode_data.IParticipant_V1>|null} [cc] Recipients_V1 cc
                 */
                /**
                 * Constructs a new Recipients_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @classdesc Represents a Recipients_V1.
                 * @implements IRecipients_V1
                 * @constructor
                 * @param {vereign.protobuf.qrcode_data.IRecipients_V1=} [properties] Properties to set
                 */
                function Recipients_V1(properties) {
                    this.to = [];
                    this.cc = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
                /**
                 * Recipients_V1 to.
                 * @member {Array.<vereign.protobuf.qrcode_data.IParticipant_V1>} to
                 * @memberof vereign.protobuf.qrcode_data.Recipients_V1
                 * @instance
                 */
                Recipients_V1.prototype.to = $util.emptyArray;
                /**
                 * Recipients_V1 cc.
                 * @member {Array.<vereign.protobuf.qrcode_data.IParticipant_V1>} cc
                 * @memberof vereign.protobuf.qrcode_data.Recipients_V1
                 * @instance
                 */
                Recipients_V1.prototype.cc = $util.emptyArray;
                /**
                 * Creates a new Recipients_V1 instance using the specified properties.
                 * @function create
                 * @memberof vereign.protobuf.qrcode_data.Recipients_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IRecipients_V1=} [properties] Properties to set
                 * @returns {vereign.protobuf.qrcode_data.Recipients_V1} Recipients_V1 instance
                 */
                Recipients_V1.create = function create(properties) {
                    return new Recipients_V1(properties);
                };
                /**
                 * Encodes the specified Recipients_V1 message. Does not implicitly {@link vereign.protobuf.qrcode_data.Recipients_V1.verify|verify} messages.
                 * @function encode
                 * @memberof vereign.protobuf.qrcode_data.Recipients_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IRecipients_V1} message Recipients_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Recipients_V1.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.to != null && message.to.length)
                        for (var i = 0; i < message.to.length; ++i)
                            $root.vereign.protobuf.qrcode_data.Participant_V1.encode(message.to[i], writer.uint32(/* id 1, wireType 2 =*/ 10).fork()).ldelim();
                    if (message.cc != null && message.cc.length)
                        for (var i = 0; i < message.cc.length; ++i)
                            $root.vereign.protobuf.qrcode_data.Participant_V1.encode(message.cc[i], writer.uint32(/* id 2, wireType 2 =*/ 18).fork()).ldelim();
                    return writer;
                };
                /**
                 * Encodes the specified Recipients_V1 message, length delimited. Does not implicitly {@link vereign.protobuf.qrcode_data.Recipients_V1.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.Recipients_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IRecipients_V1} message Recipients_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Recipients_V1.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
                /**
                 * Decodes a Recipients_V1 message from the specified reader or buffer.
                 * @function decode
                 * @memberof vereign.protobuf.qrcode_data.Recipients_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {vereign.protobuf.qrcode_data.Recipients_V1} Recipients_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Recipients_V1.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.vereign.protobuf.qrcode_data.Recipients_V1();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                            case 1:
                                if (!(message.to && message.to.length))
                                    message.to = [];
                                message.to.push($root.vereign.protobuf.qrcode_data.Participant_V1.decode(reader, reader.uint32()));
                                break;
                            case 2:
                                if (!(message.cc && message.cc.length))
                                    message.cc = [];
                                message.cc.push($root.vereign.protobuf.qrcode_data.Participant_V1.decode(reader, reader.uint32()));
                                break;
                            default:
                                reader.skipType(tag & 7);
                                break;
                        }
                    }
                    return message;
                };
                /**
                 * Decodes a Recipients_V1 message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.Recipients_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {vereign.protobuf.qrcode_data.Recipients_V1} Recipients_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Recipients_V1.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
                /**
                 * Verifies a Recipients_V1 message.
                 * @function verify
                 * @memberof vereign.protobuf.qrcode_data.Recipients_V1
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Recipients_V1.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.to != null && message.hasOwnProperty("to")) {
                        if (!Array.isArray(message.to))
                            return "to: array expected";
                        for (var i = 0; i < message.to.length; ++i) {
                            var error = $root.vereign.protobuf.qrcode_data.Participant_V1.verify(message.to[i]);
                            if (error)
                                return "to." + error;
                        }
                    }
                    if (message.cc != null && message.hasOwnProperty("cc")) {
                        if (!Array.isArray(message.cc))
                            return "cc: array expected";
                        for (var i = 0; i < message.cc.length; ++i) {
                            var error = $root.vereign.protobuf.qrcode_data.Participant_V1.verify(message.cc[i]);
                            if (error)
                                return "cc." + error;
                        }
                    }
                    return null;
                };
                /**
                 * Creates a Recipients_V1 message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof vereign.protobuf.qrcode_data.Recipients_V1
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {vereign.protobuf.qrcode_data.Recipients_V1} Recipients_V1
                 */
                Recipients_V1.fromObject = function fromObject(object) {
                    if (object instanceof $root.vereign.protobuf.qrcode_data.Recipients_V1)
                        return object;
                    var message = new $root.vereign.protobuf.qrcode_data.Recipients_V1();
                    if (object.to) {
                        if (!Array.isArray(object.to))
                            throw TypeError(".vereign.protobuf.qrcode_data.Recipients_V1.to: array expected");
                        message.to = [];
                        for (var i = 0; i < object.to.length; ++i) {
                            if (typeof object.to[i] !== "object")
                                throw TypeError(".vereign.protobuf.qrcode_data.Recipients_V1.to: object expected");
                            message.to[i] = $root.vereign.protobuf.qrcode_data.Participant_V1.fromObject(object.to[i]);
                        }
                    }
                    if (object.cc) {
                        if (!Array.isArray(object.cc))
                            throw TypeError(".vereign.protobuf.qrcode_data.Recipients_V1.cc: array expected");
                        message.cc = [];
                        for (var i = 0; i < object.cc.length; ++i) {
                            if (typeof object.cc[i] !== "object")
                                throw TypeError(".vereign.protobuf.qrcode_data.Recipients_V1.cc: object expected");
                            message.cc[i] = $root.vereign.protobuf.qrcode_data.Participant_V1.fromObject(object.cc[i]);
                        }
                    }
                    return message;
                };
                /**
                 * Creates a plain object from a Recipients_V1 message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof vereign.protobuf.qrcode_data.Recipients_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.Recipients_V1} message Recipients_V1
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Recipients_V1.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.to = [];
                        object.cc = [];
                    }
                    if (message.to && message.to.length) {
                        object.to = [];
                        for (var j = 0; j < message.to.length; ++j)
                            object.to[j] = $root.vereign.protobuf.qrcode_data.Participant_V1.toObject(message.to[j], options);
                    }
                    if (message.cc && message.cc.length) {
                        object.cc = [];
                        for (var j = 0; j < message.cc.length; ++j)
                            object.cc[j] = $root.vereign.protobuf.qrcode_data.Participant_V1.toObject(message.cc[j], options);
                    }
                    return object;
                };
                /**
                 * Converts this Recipients_V1 to JSON.
                 * @function toJSON
                 * @memberof vereign.protobuf.qrcode_data.Recipients_V1
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Recipients_V1.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
                return Recipients_V1;
            })();
            qrcode_data.IpfsContentData_V1 = (function () {
                /**
                 * Properties of an IpfsContentData_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @interface IIpfsContentData_V1
                 * @property {string|null} [cid] IpfsContentData_V1 cid
                 * @property {string|null} [key] IpfsContentData_V1 key
                 * @property {string|null} [head] IpfsContentData_V1 head
                 */
                /**
                 * Constructs a new IpfsContentData_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @classdesc Represents an IpfsContentData_V1.
                 * @implements IIpfsContentData_V1
                 * @constructor
                 * @param {vereign.protobuf.qrcode_data.IIpfsContentData_V1=} [properties] Properties to set
                 */
                function IpfsContentData_V1(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
                /**
                 * IpfsContentData_V1 cid.
                 * @member {string} cid
                 * @memberof vereign.protobuf.qrcode_data.IpfsContentData_V1
                 * @instance
                 */
                IpfsContentData_V1.prototype.cid = "";
                /**
                 * IpfsContentData_V1 key.
                 * @member {string} key
                 * @memberof vereign.protobuf.qrcode_data.IpfsContentData_V1
                 * @instance
                 */
                IpfsContentData_V1.prototype.key = "";
                /**
                 * IpfsContentData_V1 head.
                 * @member {string} head
                 * @memberof vereign.protobuf.qrcode_data.IpfsContentData_V1
                 * @instance
                 */
                IpfsContentData_V1.prototype.head = "";
                /**
                 * Creates a new IpfsContentData_V1 instance using the specified properties.
                 * @function create
                 * @memberof vereign.protobuf.qrcode_data.IpfsContentData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IIpfsContentData_V1=} [properties] Properties to set
                 * @returns {vereign.protobuf.qrcode_data.IpfsContentData_V1} IpfsContentData_V1 instance
                 */
                IpfsContentData_V1.create = function create(properties) {
                    return new IpfsContentData_V1(properties);
                };
                /**
                 * Encodes the specified IpfsContentData_V1 message. Does not implicitly {@link vereign.protobuf.qrcode_data.IpfsContentData_V1.verify|verify} messages.
                 * @function encode
                 * @memberof vereign.protobuf.qrcode_data.IpfsContentData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IIpfsContentData_V1} message IpfsContentData_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                IpfsContentData_V1.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.cid != null && Object.hasOwnProperty.call(message, "cid"))
                        writer.uint32(/* id 1, wireType 2 =*/ 10).string(message.cid);
                    if (message.key != null && Object.hasOwnProperty.call(message, "key"))
                        writer.uint32(/* id 2, wireType 2 =*/ 18).string(message.key);
                    if (message.head != null && Object.hasOwnProperty.call(message, "head"))
                        writer.uint32(/* id 3, wireType 2 =*/ 26).string(message.head);
                    return writer;
                };
                /**
                 * Encodes the specified IpfsContentData_V1 message, length delimited. Does not implicitly {@link vereign.protobuf.qrcode_data.IpfsContentData_V1.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.IpfsContentData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IIpfsContentData_V1} message IpfsContentData_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                IpfsContentData_V1.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
                /**
                 * Decodes an IpfsContentData_V1 message from the specified reader or buffer.
                 * @function decode
                 * @memberof vereign.protobuf.qrcode_data.IpfsContentData_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {vereign.protobuf.qrcode_data.IpfsContentData_V1} IpfsContentData_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                IpfsContentData_V1.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.vereign.protobuf.qrcode_data.IpfsContentData_V1();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                            case 1:
                                message.cid = reader.string();
                                break;
                            case 2:
                                message.key = reader.string();
                                break;
                            case 3:
                                message.head = reader.string();
                                break;
                            default:
                                reader.skipType(tag & 7);
                                break;
                        }
                    }
                    return message;
                };
                /**
                 * Decodes an IpfsContentData_V1 message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.IpfsContentData_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {vereign.protobuf.qrcode_data.IpfsContentData_V1} IpfsContentData_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                IpfsContentData_V1.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
                /**
                 * Verifies an IpfsContentData_V1 message.
                 * @function verify
                 * @memberof vereign.protobuf.qrcode_data.IpfsContentData_V1
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                IpfsContentData_V1.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.cid != null && message.hasOwnProperty("cid"))
                        if (!$util.isString(message.cid))
                            return "cid: string expected";
                    if (message.key != null && message.hasOwnProperty("key"))
                        if (!$util.isString(message.key))
                            return "key: string expected";
                    if (message.head != null && message.hasOwnProperty("head"))
                        if (!$util.isString(message.head))
                            return "head: string expected";
                    return null;
                };
                /**
                 * Creates an IpfsContentData_V1 message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof vereign.protobuf.qrcode_data.IpfsContentData_V1
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {vereign.protobuf.qrcode_data.IpfsContentData_V1} IpfsContentData_V1
                 */
                IpfsContentData_V1.fromObject = function fromObject(object) {
                    if (object instanceof $root.vereign.protobuf.qrcode_data.IpfsContentData_V1)
                        return object;
                    var message = new $root.vereign.protobuf.qrcode_data.IpfsContentData_V1();
                    if (object.cid != null)
                        message.cid = String(object.cid);
                    if (object.key != null)
                        message.key = String(object.key);
                    if (object.head != null)
                        message.head = String(object.head);
                    return message;
                };
                /**
                 * Creates a plain object from an IpfsContentData_V1 message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof vereign.protobuf.qrcode_data.IpfsContentData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IpfsContentData_V1} message IpfsContentData_V1
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                IpfsContentData_V1.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.cid = "";
                        object.key = "";
                        object.head = "";
                    }
                    if (message.cid != null && message.hasOwnProperty("cid"))
                        object.cid = message.cid;
                    if (message.key != null && message.hasOwnProperty("key"))
                        object.key = message.key;
                    if (message.head != null && message.hasOwnProperty("head"))
                        object.head = message.head;
                    return object;
                };
                /**
                 * Converts this IpfsContentData_V1 to JSON.
                 * @function toJSON
                 * @memberof vereign.protobuf.qrcode_data.IpfsContentData_V1
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                IpfsContentData_V1.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
                return IpfsContentData_V1;
            })();
            qrcode_data.IpfsAttachmentData_V1 = (function () {
                /**
                 * Properties of an IpfsAttachmentData_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @interface IIpfsAttachmentData_V1
                 * @property {string|null} [cid] IpfsAttachmentData_V1 cid
                 * @property {string|null} [key] IpfsAttachmentData_V1 key
                 * @property {string|null} [contentHash] IpfsAttachmentData_V1 contentHash
                 * @property {string|null} [head] IpfsAttachmentData_V1 head
                 * @property {string|null} [contentType] IpfsAttachmentData_V1 contentType
                 */
                /**
                 * Constructs a new IpfsAttachmentData_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @classdesc Represents an IpfsAttachmentData_V1.
                 * @implements IIpfsAttachmentData_V1
                 * @constructor
                 * @param {vereign.protobuf.qrcode_data.IIpfsAttachmentData_V1=} [properties] Properties to set
                 */
                function IpfsAttachmentData_V1(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
                /**
                 * IpfsAttachmentData_V1 cid.
                 * @member {string} cid
                 * @memberof vereign.protobuf.qrcode_data.IpfsAttachmentData_V1
                 * @instance
                 */
                IpfsAttachmentData_V1.prototype.cid = "";
                /**
                 * IpfsAttachmentData_V1 key.
                 * @member {string} key
                 * @memberof vereign.protobuf.qrcode_data.IpfsAttachmentData_V1
                 * @instance
                 */
                IpfsAttachmentData_V1.prototype.key = "";
                /**
                 * IpfsAttachmentData_V1 contentHash.
                 * @member {string} contentHash
                 * @memberof vereign.protobuf.qrcode_data.IpfsAttachmentData_V1
                 * @instance
                 */
                IpfsAttachmentData_V1.prototype.contentHash = "";
                /**
                 * IpfsAttachmentData_V1 head.
                 * @member {string} head
                 * @memberof vereign.protobuf.qrcode_data.IpfsAttachmentData_V1
                 * @instance
                 */
                IpfsAttachmentData_V1.prototype.head = "";
                /**
                 * IpfsAttachmentData_V1 contentType.
                 * @member {string} contentType
                 * @memberof vereign.protobuf.qrcode_data.IpfsAttachmentData_V1
                 * @instance
                 */
                IpfsAttachmentData_V1.prototype.contentType = "";
                /**
                 * Creates a new IpfsAttachmentData_V1 instance using the specified properties.
                 * @function create
                 * @memberof vereign.protobuf.qrcode_data.IpfsAttachmentData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IIpfsAttachmentData_V1=} [properties] Properties to set
                 * @returns {vereign.protobuf.qrcode_data.IpfsAttachmentData_V1} IpfsAttachmentData_V1 instance
                 */
                IpfsAttachmentData_V1.create = function create(properties) {
                    return new IpfsAttachmentData_V1(properties);
                };
                /**
                 * Encodes the specified IpfsAttachmentData_V1 message. Does not implicitly {@link vereign.protobuf.qrcode_data.IpfsAttachmentData_V1.verify|verify} messages.
                 * @function encode
                 * @memberof vereign.protobuf.qrcode_data.IpfsAttachmentData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IIpfsAttachmentData_V1} message IpfsAttachmentData_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                IpfsAttachmentData_V1.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.cid != null && Object.hasOwnProperty.call(message, "cid"))
                        writer.uint32(/* id 1, wireType 2 =*/ 10).string(message.cid);
                    if (message.key != null && Object.hasOwnProperty.call(message, "key"))
                        writer.uint32(/* id 2, wireType 2 =*/ 18).string(message.key);
                    if (message.contentHash != null && Object.hasOwnProperty.call(message, "contentHash"))
                        writer.uint32(/* id 3, wireType 2 =*/ 26).string(message.contentHash);
                    if (message.head != null && Object.hasOwnProperty.call(message, "head"))
                        writer.uint32(/* id 4, wireType 2 =*/ 34).string(message.head);
                    if (message.contentType != null && Object.hasOwnProperty.call(message, "contentType"))
                        writer.uint32(/* id 5, wireType 2 =*/ 42).string(message.contentType);
                    return writer;
                };
                /**
                 * Encodes the specified IpfsAttachmentData_V1 message, length delimited. Does not implicitly {@link vereign.protobuf.qrcode_data.IpfsAttachmentData_V1.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.IpfsAttachmentData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IIpfsAttachmentData_V1} message IpfsAttachmentData_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                IpfsAttachmentData_V1.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
                /**
                 * Decodes an IpfsAttachmentData_V1 message from the specified reader or buffer.
                 * @function decode
                 * @memberof vereign.protobuf.qrcode_data.IpfsAttachmentData_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {vereign.protobuf.qrcode_data.IpfsAttachmentData_V1} IpfsAttachmentData_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                IpfsAttachmentData_V1.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.vereign.protobuf.qrcode_data.IpfsAttachmentData_V1();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                            case 1:
                                message.cid = reader.string();
                                break;
                            case 2:
                                message.key = reader.string();
                                break;
                            case 3:
                                message.contentHash = reader.string();
                                break;
                            case 4:
                                message.head = reader.string();
                                break;
                            case 5:
                                message.contentType = reader.string();
                                break;
                            default:
                                reader.skipType(tag & 7);
                                break;
                        }
                    }
                    return message;
                };
                /**
                 * Decodes an IpfsAttachmentData_V1 message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.IpfsAttachmentData_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {vereign.protobuf.qrcode_data.IpfsAttachmentData_V1} IpfsAttachmentData_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                IpfsAttachmentData_V1.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
                /**
                 * Verifies an IpfsAttachmentData_V1 message.
                 * @function verify
                 * @memberof vereign.protobuf.qrcode_data.IpfsAttachmentData_V1
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                IpfsAttachmentData_V1.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.cid != null && message.hasOwnProperty("cid"))
                        if (!$util.isString(message.cid))
                            return "cid: string expected";
                    if (message.key != null && message.hasOwnProperty("key"))
                        if (!$util.isString(message.key))
                            return "key: string expected";
                    if (message.contentHash != null && message.hasOwnProperty("contentHash"))
                        if (!$util.isString(message.contentHash))
                            return "contentHash: string expected";
                    if (message.head != null && message.hasOwnProperty("head"))
                        if (!$util.isString(message.head))
                            return "head: string expected";
                    if (message.contentType != null && message.hasOwnProperty("contentType"))
                        if (!$util.isString(message.contentType))
                            return "contentType: string expected";
                    return null;
                };
                /**
                 * Creates an IpfsAttachmentData_V1 message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof vereign.protobuf.qrcode_data.IpfsAttachmentData_V1
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {vereign.protobuf.qrcode_data.IpfsAttachmentData_V1} IpfsAttachmentData_V1
                 */
                IpfsAttachmentData_V1.fromObject = function fromObject(object) {
                    if (object instanceof $root.vereign.protobuf.qrcode_data.IpfsAttachmentData_V1)
                        return object;
                    var message = new $root.vereign.protobuf.qrcode_data.IpfsAttachmentData_V1();
                    if (object.cid != null)
                        message.cid = String(object.cid);
                    if (object.key != null)
                        message.key = String(object.key);
                    if (object.contentHash != null)
                        message.contentHash = String(object.contentHash);
                    if (object.head != null)
                        message.head = String(object.head);
                    if (object.contentType != null)
                        message.contentType = String(object.contentType);
                    return message;
                };
                /**
                 * Creates a plain object from an IpfsAttachmentData_V1 message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof vereign.protobuf.qrcode_data.IpfsAttachmentData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IpfsAttachmentData_V1} message IpfsAttachmentData_V1
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                IpfsAttachmentData_V1.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.cid = "";
                        object.key = "";
                        object.contentHash = "";
                        object.head = "";
                        object.contentType = "";
                    }
                    if (message.cid != null && message.hasOwnProperty("cid"))
                        object.cid = message.cid;
                    if (message.key != null && message.hasOwnProperty("key"))
                        object.key = message.key;
                    if (message.contentHash != null && message.hasOwnProperty("contentHash"))
                        object.contentHash = message.contentHash;
                    if (message.head != null && message.hasOwnProperty("head"))
                        object.head = message.head;
                    if (message.contentType != null && message.hasOwnProperty("contentType"))
                        object.contentType = message.contentType;
                    return object;
                };
                /**
                 * Converts this IpfsAttachmentData_V1 to JSON.
                 * @function toJSON
                 * @memberof vereign.protobuf.qrcode_data.IpfsAttachmentData_V1
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                IpfsAttachmentData_V1.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
                return IpfsAttachmentData_V1;
            })();
            qrcode_data.IpfsData_V1 = (function () {
                /**
                 * Properties of an IpfsData_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @interface IIpfsData_V1
                 * @property {vereign.protobuf.qrcode_data.IIpfsContentData_V1|null} [plaintText] IpfsData_V1 plaintText
                 * @property {vereign.protobuf.qrcode_data.IIpfsContentData_V1|null} [html] IpfsData_V1 html
                 * @property {Array.<vereign.protobuf.qrcode_data.IIpfsAttachmentData_V1>|null} [attachments] IpfsData_V1 attachments
                 * @property {string|null} [version] IpfsData_V1 version
                 */
                /**
                 * Constructs a new IpfsData_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @classdesc Represents an IpfsData_V1.
                 * @implements IIpfsData_V1
                 * @constructor
                 * @param {vereign.protobuf.qrcode_data.IIpfsData_V1=} [properties] Properties to set
                 */
                function IpfsData_V1(properties) {
                    this.attachments = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
                /**
                 * IpfsData_V1 plaintText.
                 * @member {vereign.protobuf.qrcode_data.IIpfsContentData_V1|null|undefined} plaintText
                 * @memberof vereign.protobuf.qrcode_data.IpfsData_V1
                 * @instance
                 */
                IpfsData_V1.prototype.plaintText = null;
                /**
                 * IpfsData_V1 html.
                 * @member {vereign.protobuf.qrcode_data.IIpfsContentData_V1|null|undefined} html
                 * @memberof vereign.protobuf.qrcode_data.IpfsData_V1
                 * @instance
                 */
                IpfsData_V1.prototype.html = null;
                /**
                 * IpfsData_V1 attachments.
                 * @member {Array.<vereign.protobuf.qrcode_data.IIpfsAttachmentData_V1>} attachments
                 * @memberof vereign.protobuf.qrcode_data.IpfsData_V1
                 * @instance
                 */
                IpfsData_V1.prototype.attachments = $util.emptyArray;
                /**
                 * IpfsData_V1 version.
                 * @member {string} version
                 * @memberof vereign.protobuf.qrcode_data.IpfsData_V1
                 * @instance
                 */
                IpfsData_V1.prototype.version = "";
                /**
                 * Creates a new IpfsData_V1 instance using the specified properties.
                 * @function create
                 * @memberof vereign.protobuf.qrcode_data.IpfsData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IIpfsData_V1=} [properties] Properties to set
                 * @returns {vereign.protobuf.qrcode_data.IpfsData_V1} IpfsData_V1 instance
                 */
                IpfsData_V1.create = function create(properties) {
                    return new IpfsData_V1(properties);
                };
                /**
                 * Encodes the specified IpfsData_V1 message. Does not implicitly {@link vereign.protobuf.qrcode_data.IpfsData_V1.verify|verify} messages.
                 * @function encode
                 * @memberof vereign.protobuf.qrcode_data.IpfsData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IIpfsData_V1} message IpfsData_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                IpfsData_V1.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.plaintText != null && Object.hasOwnProperty.call(message, "plaintText"))
                        $root.vereign.protobuf.qrcode_data.IpfsContentData_V1.encode(message.plaintText, writer.uint32(/* id 1, wireType 2 =*/ 10).fork()).ldelim();
                    if (message.html != null && Object.hasOwnProperty.call(message, "html"))
                        $root.vereign.protobuf.qrcode_data.IpfsContentData_V1.encode(message.html, writer.uint32(/* id 2, wireType 2 =*/ 18).fork()).ldelim();
                    if (message.attachments != null && message.attachments.length)
                        for (var i = 0; i < message.attachments.length; ++i)
                            $root.vereign.protobuf.qrcode_data.IpfsAttachmentData_V1.encode(message.attachments[i], writer.uint32(/* id 3, wireType 2 =*/ 26).fork()).ldelim();
                    if (message.version != null && Object.hasOwnProperty.call(message, "version"))
                        writer.uint32(/* id 4, wireType 2 =*/ 34).string(message.version);
                    return writer;
                };
                /**
                 * Encodes the specified IpfsData_V1 message, length delimited. Does not implicitly {@link vereign.protobuf.qrcode_data.IpfsData_V1.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.IpfsData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IIpfsData_V1} message IpfsData_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                IpfsData_V1.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
                /**
                 * Decodes an IpfsData_V1 message from the specified reader or buffer.
                 * @function decode
                 * @memberof vereign.protobuf.qrcode_data.IpfsData_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {vereign.protobuf.qrcode_data.IpfsData_V1} IpfsData_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                IpfsData_V1.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.vereign.protobuf.qrcode_data.IpfsData_V1();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                            case 1:
                                message.plaintText = $root.vereign.protobuf.qrcode_data.IpfsContentData_V1.decode(reader, reader.uint32());
                                break;
                            case 2:
                                message.html = $root.vereign.protobuf.qrcode_data.IpfsContentData_V1.decode(reader, reader.uint32());
                                break;
                            case 3:
                                if (!(message.attachments && message.attachments.length))
                                    message.attachments = [];
                                message.attachments.push($root.vereign.protobuf.qrcode_data.IpfsAttachmentData_V1.decode(reader, reader.uint32()));
                                break;
                            case 4:
                                message.version = reader.string();
                                break;
                            default:
                                reader.skipType(tag & 7);
                                break;
                        }
                    }
                    return message;
                };
                /**
                 * Decodes an IpfsData_V1 message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.IpfsData_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {vereign.protobuf.qrcode_data.IpfsData_V1} IpfsData_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                IpfsData_V1.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
                /**
                 * Verifies an IpfsData_V1 message.
                 * @function verify
                 * @memberof vereign.protobuf.qrcode_data.IpfsData_V1
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                IpfsData_V1.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.plaintText != null && message.hasOwnProperty("plaintText")) {
                        var error = $root.vereign.protobuf.qrcode_data.IpfsContentData_V1.verify(message.plaintText);
                        if (error)
                            return "plaintText." + error;
                    }
                    if (message.html != null && message.hasOwnProperty("html")) {
                        var error = $root.vereign.protobuf.qrcode_data.IpfsContentData_V1.verify(message.html);
                        if (error)
                            return "html." + error;
                    }
                    if (message.attachments != null && message.hasOwnProperty("attachments")) {
                        if (!Array.isArray(message.attachments))
                            return "attachments: array expected";
                        for (var i = 0; i < message.attachments.length; ++i) {
                            var error = $root.vereign.protobuf.qrcode_data.IpfsAttachmentData_V1.verify(message.attachments[i]);
                            if (error)
                                return "attachments." + error;
                        }
                    }
                    if (message.version != null && message.hasOwnProperty("version"))
                        if (!$util.isString(message.version))
                            return "version: string expected";
                    return null;
                };
                /**
                 * Creates an IpfsData_V1 message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof vereign.protobuf.qrcode_data.IpfsData_V1
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {vereign.protobuf.qrcode_data.IpfsData_V1} IpfsData_V1
                 */
                IpfsData_V1.fromObject = function fromObject(object) {
                    if (object instanceof $root.vereign.protobuf.qrcode_data.IpfsData_V1)
                        return object;
                    var message = new $root.vereign.protobuf.qrcode_data.IpfsData_V1();
                    if (object.plaintText != null) {
                        if (typeof object.plaintText !== "object")
                            throw TypeError(".vereign.protobuf.qrcode_data.IpfsData_V1.plaintText: object expected");
                        message.plaintText = $root.vereign.protobuf.qrcode_data.IpfsContentData_V1.fromObject(object.plaintText);
                    }
                    if (object.html != null) {
                        if (typeof object.html !== "object")
                            throw TypeError(".vereign.protobuf.qrcode_data.IpfsData_V1.html: object expected");
                        message.html = $root.vereign.protobuf.qrcode_data.IpfsContentData_V1.fromObject(object.html);
                    }
                    if (object.attachments) {
                        if (!Array.isArray(object.attachments))
                            throw TypeError(".vereign.protobuf.qrcode_data.IpfsData_V1.attachments: array expected");
                        message.attachments = [];
                        for (var i = 0; i < object.attachments.length; ++i) {
                            if (typeof object.attachments[i] !== "object")
                                throw TypeError(".vereign.protobuf.qrcode_data.IpfsData_V1.attachments: object expected");
                            message.attachments[i] = $root.vereign.protobuf.qrcode_data.IpfsAttachmentData_V1.fromObject(object.attachments[i]);
                        }
                    }
                    if (object.version != null)
                        message.version = String(object.version);
                    return message;
                };
                /**
                 * Creates a plain object from an IpfsData_V1 message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof vereign.protobuf.qrcode_data.IpfsData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IpfsData_V1} message IpfsData_V1
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                IpfsData_V1.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.attachments = [];
                    if (options.defaults) {
                        object.plaintText = null;
                        object.html = null;
                        object.version = "";
                    }
                    if (message.plaintText != null && message.hasOwnProperty("plaintText"))
                        object.plaintText = $root.vereign.protobuf.qrcode_data.IpfsContentData_V1.toObject(message.plaintText, options);
                    if (message.html != null && message.hasOwnProperty("html"))
                        object.html = $root.vereign.protobuf.qrcode_data.IpfsContentData_V1.toObject(message.html, options);
                    if (message.attachments && message.attachments.length) {
                        object.attachments = [];
                        for (var j = 0; j < message.attachments.length; ++j)
                            object.attachments[j] = $root.vereign.protobuf.qrcode_data.IpfsAttachmentData_V1.toObject(message.attachments[j], options);
                    }
                    if (message.version != null && message.hasOwnProperty("version"))
                        object.version = message.version;
                    return object;
                };
                /**
                 * Converts this IpfsData_V1 to JSON.
                 * @function toJSON
                 * @memberof vereign.protobuf.qrcode_data.IpfsData_V1
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                IpfsData_V1.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
                return IpfsData_V1;
            })();
            qrcode_data.EmailData_V1 = (function () {
                /**
                 * Properties of an EmailData_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @interface IEmailData_V1
                 * @property {string|null} [statusId] EmailData_V1 statusId
                 * @property {vereign.protobuf.qrcode_data.IParticipant_V1|null} [sender] EmailData_V1 sender
                 * @property {string|null} [subject] EmailData_V1 subject
                 * @property {string|null} [date] EmailData_V1 date
                 * @property {vereign.protobuf.qrcode_data.IRecipients_V1|null} [recipients] EmailData_V1 recipients
                 * @property {Array.<vereign.protobuf.qrcode_data.IAttachment_V1>|null} [attachments] EmailData_V1 attachments
                 * @property {string|null} [senderPublicKeyUuid] EmailData_V1 senderPublicKeyUuid
                 * @property {vereign.protobuf.qrcode_data.IIpfsData_V1|null} [ipfs] EmailData_V1 ipfs
                 */
                /**
                 * Constructs a new EmailData_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @classdesc Represents an EmailData_V1.
                 * @implements IEmailData_V1
                 * @constructor
                 * @param {vereign.protobuf.qrcode_data.IEmailData_V1=} [properties] Properties to set
                 */
                function EmailData_V1(properties) {
                    this.attachments = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
                /**
                 * EmailData_V1 statusId.
                 * @member {string} statusId
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @instance
                 */
                EmailData_V1.prototype.statusId = "";
                /**
                 * EmailData_V1 sender.
                 * @member {vereign.protobuf.qrcode_data.IParticipant_V1|null|undefined} sender
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @instance
                 */
                EmailData_V1.prototype.sender = null;
                /**
                 * EmailData_V1 subject.
                 * @member {string} subject
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @instance
                 */
                EmailData_V1.prototype.subject = "";
                /**
                 * EmailData_V1 date.
                 * @member {string} date
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @instance
                 */
                EmailData_V1.prototype.date = "";
                /**
                 * EmailData_V1 recipients.
                 * @member {vereign.protobuf.qrcode_data.IRecipients_V1|null|undefined} recipients
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @instance
                 */
                EmailData_V1.prototype.recipients = null;
                /**
                 * EmailData_V1 attachments.
                 * @member {Array.<vereign.protobuf.qrcode_data.IAttachment_V1>} attachments
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @instance
                 */
                EmailData_V1.prototype.attachments = $util.emptyArray;
                /**
                 * EmailData_V1 senderPublicKeyUuid.
                 * @member {string} senderPublicKeyUuid
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @instance
                 */
                EmailData_V1.prototype.senderPublicKeyUuid = "";
                /**
                 * EmailData_V1 ipfs.
                 * @member {vereign.protobuf.qrcode_data.IIpfsData_V1|null|undefined} ipfs
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @instance
                 */
                EmailData_V1.prototype.ipfs = null;
                /**
                 * Creates a new EmailData_V1 instance using the specified properties.
                 * @function create
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IEmailData_V1=} [properties] Properties to set
                 * @returns {vereign.protobuf.qrcode_data.EmailData_V1} EmailData_V1 instance
                 */
                EmailData_V1.create = function create(properties) {
                    return new EmailData_V1(properties);
                };
                /**
                 * Encodes the specified EmailData_V1 message. Does not implicitly {@link vereign.protobuf.qrcode_data.EmailData_V1.verify|verify} messages.
                 * @function encode
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IEmailData_V1} message EmailData_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EmailData_V1.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.statusId != null && Object.hasOwnProperty.call(message, "statusId"))
                        writer.uint32(/* id 1, wireType 2 =*/ 10).string(message.statusId);
                    if (message.sender != null && Object.hasOwnProperty.call(message, "sender"))
                        $root.vereign.protobuf.qrcode_data.Participant_V1.encode(message.sender, writer.uint32(/* id 2, wireType 2 =*/ 18).fork()).ldelim();
                    if (message.subject != null && Object.hasOwnProperty.call(message, "subject"))
                        writer.uint32(/* id 3, wireType 2 =*/ 26).string(message.subject);
                    if (message.date != null && Object.hasOwnProperty.call(message, "date"))
                        writer.uint32(/* id 4, wireType 2 =*/ 34).string(message.date);
                    if (message.recipients != null && Object.hasOwnProperty.call(message, "recipients"))
                        $root.vereign.protobuf.qrcode_data.Recipients_V1.encode(message.recipients, writer.uint32(/* id 5, wireType 2 =*/ 42).fork()).ldelim();
                    if (message.attachments != null && message.attachments.length)
                        for (var i = 0; i < message.attachments.length; ++i)
                            $root.vereign.protobuf.qrcode_data.Attachment_V1.encode(message.attachments[i], writer.uint32(/* id 6, wireType 2 =*/ 50).fork()).ldelim();
                    if (message.senderPublicKeyUuid != null && Object.hasOwnProperty.call(message, "senderPublicKeyUuid"))
                        writer.uint32(/* id 7, wireType 2 =*/ 58).string(message.senderPublicKeyUuid);
                    if (message.ipfs != null && Object.hasOwnProperty.call(message, "ipfs"))
                        $root.vereign.protobuf.qrcode_data.IpfsData_V1.encode(message.ipfs, writer.uint32(/* id 8, wireType 2 =*/ 66).fork()).ldelim();
                    return writer;
                };
                /**
                 * Encodes the specified EmailData_V1 message, length delimited. Does not implicitly {@link vereign.protobuf.qrcode_data.EmailData_V1.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IEmailData_V1} message EmailData_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EmailData_V1.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
                /**
                 * Decodes an EmailData_V1 message from the specified reader or buffer.
                 * @function decode
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {vereign.protobuf.qrcode_data.EmailData_V1} EmailData_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EmailData_V1.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.vereign.protobuf.qrcode_data.EmailData_V1();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                            case 1:
                                message.statusId = reader.string();
                                break;
                            case 2:
                                message.sender = $root.vereign.protobuf.qrcode_data.Participant_V1.decode(reader, reader.uint32());
                                break;
                            case 3:
                                message.subject = reader.string();
                                break;
                            case 4:
                                message.date = reader.string();
                                break;
                            case 5:
                                message.recipients = $root.vereign.protobuf.qrcode_data.Recipients_V1.decode(reader, reader.uint32());
                                break;
                            case 6:
                                if (!(message.attachments && message.attachments.length))
                                    message.attachments = [];
                                message.attachments.push($root.vereign.protobuf.qrcode_data.Attachment_V1.decode(reader, reader.uint32()));
                                break;
                            case 7:
                                message.senderPublicKeyUuid = reader.string();
                                break;
                            case 8:
                                message.ipfs = $root.vereign.protobuf.qrcode_data.IpfsData_V1.decode(reader, reader.uint32());
                                break;
                            default:
                                reader.skipType(tag & 7);
                                break;
                        }
                    }
                    return message;
                };
                /**
                 * Decodes an EmailData_V1 message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {vereign.protobuf.qrcode_data.EmailData_V1} EmailData_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EmailData_V1.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
                /**
                 * Verifies an EmailData_V1 message.
                 * @function verify
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                EmailData_V1.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.statusId != null && message.hasOwnProperty("statusId"))
                        if (!$util.isString(message.statusId))
                            return "statusId: string expected";
                    if (message.sender != null && message.hasOwnProperty("sender")) {
                        var error = $root.vereign.protobuf.qrcode_data.Participant_V1.verify(message.sender);
                        if (error)
                            return "sender." + error;
                    }
                    if (message.subject != null && message.hasOwnProperty("subject"))
                        if (!$util.isString(message.subject))
                            return "subject: string expected";
                    if (message.date != null && message.hasOwnProperty("date"))
                        if (!$util.isString(message.date))
                            return "date: string expected";
                    if (message.recipients != null && message.hasOwnProperty("recipients")) {
                        var error = $root.vereign.protobuf.qrcode_data.Recipients_V1.verify(message.recipients);
                        if (error)
                            return "recipients." + error;
                    }
                    if (message.attachments != null && message.hasOwnProperty("attachments")) {
                        if (!Array.isArray(message.attachments))
                            return "attachments: array expected";
                        for (var i = 0; i < message.attachments.length; ++i) {
                            var error = $root.vereign.protobuf.qrcode_data.Attachment_V1.verify(message.attachments[i]);
                            if (error)
                                return "attachments." + error;
                        }
                    }
                    if (message.senderPublicKeyUuid != null && message.hasOwnProperty("senderPublicKeyUuid"))
                        if (!$util.isString(message.senderPublicKeyUuid))
                            return "senderPublicKeyUuid: string expected";
                    if (message.ipfs != null && message.hasOwnProperty("ipfs")) {
                        var error = $root.vereign.protobuf.qrcode_data.IpfsData_V1.verify(message.ipfs);
                        if (error)
                            return "ipfs." + error;
                    }
                    return null;
                };
                /**
                 * Creates an EmailData_V1 message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {vereign.protobuf.qrcode_data.EmailData_V1} EmailData_V1
                 */
                EmailData_V1.fromObject = function fromObject(object) {
                    if (object instanceof $root.vereign.protobuf.qrcode_data.EmailData_V1)
                        return object;
                    var message = new $root.vereign.protobuf.qrcode_data.EmailData_V1();
                    if (object.statusId != null)
                        message.statusId = String(object.statusId);
                    if (object.sender != null) {
                        if (typeof object.sender !== "object")
                            throw TypeError(".vereign.protobuf.qrcode_data.EmailData_V1.sender: object expected");
                        message.sender = $root.vereign.protobuf.qrcode_data.Participant_V1.fromObject(object.sender);
                    }
                    if (object.subject != null)
                        message.subject = String(object.subject);
                    if (object.date != null)
                        message.date = String(object.date);
                    if (object.recipients != null) {
                        if (typeof object.recipients !== "object")
                            throw TypeError(".vereign.protobuf.qrcode_data.EmailData_V1.recipients: object expected");
                        message.recipients = $root.vereign.protobuf.qrcode_data.Recipients_V1.fromObject(object.recipients);
                    }
                    if (object.attachments) {
                        if (!Array.isArray(object.attachments))
                            throw TypeError(".vereign.protobuf.qrcode_data.EmailData_V1.attachments: array expected");
                        message.attachments = [];
                        for (var i = 0; i < object.attachments.length; ++i) {
                            if (typeof object.attachments[i] !== "object")
                                throw TypeError(".vereign.protobuf.qrcode_data.EmailData_V1.attachments: object expected");
                            message.attachments[i] = $root.vereign.protobuf.qrcode_data.Attachment_V1.fromObject(object.attachments[i]);
                        }
                    }
                    if (object.senderPublicKeyUuid != null)
                        message.senderPublicKeyUuid = String(object.senderPublicKeyUuid);
                    if (object.ipfs != null) {
                        if (typeof object.ipfs !== "object")
                            throw TypeError(".vereign.protobuf.qrcode_data.EmailData_V1.ipfs: object expected");
                        message.ipfs = $root.vereign.protobuf.qrcode_data.IpfsData_V1.fromObject(object.ipfs);
                    }
                    return message;
                };
                /**
                 * Creates a plain object from an EmailData_V1 message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.EmailData_V1} message EmailData_V1
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                EmailData_V1.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.attachments = [];
                    if (options.defaults) {
                        object.statusId = "";
                        object.sender = null;
                        object.subject = "";
                        object.date = "";
                        object.recipients = null;
                        object.senderPublicKeyUuid = "";
                        object.ipfs = null;
                    }
                    if (message.statusId != null && message.hasOwnProperty("statusId"))
                        object.statusId = message.statusId;
                    if (message.sender != null && message.hasOwnProperty("sender"))
                        object.sender = $root.vereign.protobuf.qrcode_data.Participant_V1.toObject(message.sender, options);
                    if (message.subject != null && message.hasOwnProperty("subject"))
                        object.subject = message.subject;
                    if (message.date != null && message.hasOwnProperty("date"))
                        object.date = message.date;
                    if (message.recipients != null && message.hasOwnProperty("recipients"))
                        object.recipients = $root.vereign.protobuf.qrcode_data.Recipients_V1.toObject(message.recipients, options);
                    if (message.attachments && message.attachments.length) {
                        object.attachments = [];
                        for (var j = 0; j < message.attachments.length; ++j)
                            object.attachments[j] = $root.vereign.protobuf.qrcode_data.Attachment_V1.toObject(message.attachments[j], options);
                    }
                    if (message.senderPublicKeyUuid != null && message.hasOwnProperty("senderPublicKeyUuid"))
                        object.senderPublicKeyUuid = message.senderPublicKeyUuid;
                    if (message.ipfs != null && message.hasOwnProperty("ipfs"))
                        object.ipfs = $root.vereign.protobuf.qrcode_data.IpfsData_V1.toObject(message.ipfs, options);
                    return object;
                };
                /**
                 * Converts this EmailData_V1 to JSON.
                 * @function toJSON
                 * @memberof vereign.protobuf.qrcode_data.EmailData_V1
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                EmailData_V1.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
                return EmailData_V1;
            })();
            qrcode_data.KeyData_V1 = (function () {
                /**
                 * Properties of a KeyData_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @interface IKeyData_V1
                 * @property {Uint8Array|null} [key] KeyData_V1 key
                 * @property {Uint8Array|null} [data] KeyData_V1 data
                 */
                /**
                 * Constructs a new KeyData_V1.
                 * @memberof vereign.protobuf.qrcode_data
                 * @classdesc Represents a KeyData_V1.
                 * @implements IKeyData_V1
                 * @constructor
                 * @param {vereign.protobuf.qrcode_data.IKeyData_V1=} [properties] Properties to set
                 */
                function KeyData_V1(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
                /**
                 * KeyData_V1 key.
                 * @member {Uint8Array} key
                 * @memberof vereign.protobuf.qrcode_data.KeyData_V1
                 * @instance
                 */
                KeyData_V1.prototype.key = $util.newBuffer([]);
                /**
                 * KeyData_V1 data.
                 * @member {Uint8Array} data
                 * @memberof vereign.protobuf.qrcode_data.KeyData_V1
                 * @instance
                 */
                KeyData_V1.prototype.data = $util.newBuffer([]);
                /**
                 * Creates a new KeyData_V1 instance using the specified properties.
                 * @function create
                 * @memberof vereign.protobuf.qrcode_data.KeyData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IKeyData_V1=} [properties] Properties to set
                 * @returns {vereign.protobuf.qrcode_data.KeyData_V1} KeyData_V1 instance
                 */
                KeyData_V1.create = function create(properties) {
                    return new KeyData_V1(properties);
                };
                /**
                 * Encodes the specified KeyData_V1 message. Does not implicitly {@link vereign.protobuf.qrcode_data.KeyData_V1.verify|verify} messages.
                 * @function encode
                 * @memberof vereign.protobuf.qrcode_data.KeyData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IKeyData_V1} message KeyData_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                KeyData_V1.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.key != null && Object.hasOwnProperty.call(message, "key"))
                        writer.uint32(/* id 1, wireType 2 =*/ 10).bytes(message.key);
                    if (message.data != null && Object.hasOwnProperty.call(message, "data"))
                        writer.uint32(/* id 2, wireType 2 =*/ 18).bytes(message.data);
                    return writer;
                };
                /**
                 * Encodes the specified KeyData_V1 message, length delimited. Does not implicitly {@link vereign.protobuf.qrcode_data.KeyData_V1.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.KeyData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IKeyData_V1} message KeyData_V1 message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                KeyData_V1.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
                /**
                 * Decodes a KeyData_V1 message from the specified reader or buffer.
                 * @function decode
                 * @memberof vereign.protobuf.qrcode_data.KeyData_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {vereign.protobuf.qrcode_data.KeyData_V1} KeyData_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                KeyData_V1.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.vereign.protobuf.qrcode_data.KeyData_V1();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                            case 1:
                                message.key = reader.bytes();
                                break;
                            case 2:
                                message.data = reader.bytes();
                                break;
                            default:
                                reader.skipType(tag & 7);
                                break;
                        }
                    }
                    return message;
                };
                /**
                 * Decodes a KeyData_V1 message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.KeyData_V1
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {vereign.protobuf.qrcode_data.KeyData_V1} KeyData_V1
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                KeyData_V1.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
                /**
                 * Verifies a KeyData_V1 message.
                 * @function verify
                 * @memberof vereign.protobuf.qrcode_data.KeyData_V1
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                KeyData_V1.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.key != null && message.hasOwnProperty("key"))
                        if (!(message.key && typeof message.key.length === "number" || $util.isString(message.key)))
                            return "key: buffer expected";
                    if (message.data != null && message.hasOwnProperty("data"))
                        if (!(message.data && typeof message.data.length === "number" || $util.isString(message.data)))
                            return "data: buffer expected";
                    return null;
                };
                /**
                 * Creates a KeyData_V1 message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof vereign.protobuf.qrcode_data.KeyData_V1
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {vereign.protobuf.qrcode_data.KeyData_V1} KeyData_V1
                 */
                KeyData_V1.fromObject = function fromObject(object) {
                    if (object instanceof $root.vereign.protobuf.qrcode_data.KeyData_V1)
                        return object;
                    var message = new $root.vereign.protobuf.qrcode_data.KeyData_V1();
                    if (object.key != null)
                        if (typeof object.key === "string")
                            $util.base64.decode(object.key, message.key = $util.newBuffer($util.base64.length(object.key)), 0);
                        else if (object.key.length)
                            message.key = object.key;
                    if (object.data != null)
                        if (typeof object.data === "string")
                            $util.base64.decode(object.data, message.data = $util.newBuffer($util.base64.length(object.data)), 0);
                        else if (object.data.length)
                            message.data = object.data;
                    return message;
                };
                /**
                 * Creates a plain object from a KeyData_V1 message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof vereign.protobuf.qrcode_data.KeyData_V1
                 * @static
                 * @param {vereign.protobuf.qrcode_data.KeyData_V1} message KeyData_V1
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                KeyData_V1.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        if (options.bytes === String)
                            object.key = "";
                        else {
                            object.key = [];
                            if (options.bytes !== Array)
                                object.key = $util.newBuffer(object.key);
                        }
                        if (options.bytes === String)
                            object.data = "";
                        else {
                            object.data = [];
                            if (options.bytes !== Array)
                                object.data = $util.newBuffer(object.data);
                        }
                    }
                    if (message.key != null && message.hasOwnProperty("key"))
                        object.key = options.bytes === String ? $util.base64.encode(message.key, 0, message.key.length) : options.bytes === Array ? Array.prototype.slice.call(message.key) : message.key;
                    if (message.data != null && message.hasOwnProperty("data"))
                        object.data = options.bytes === String ? $util.base64.encode(message.data, 0, message.data.length) : options.bytes === Array ? Array.prototype.slice.call(message.data) : message.data;
                    return object;
                };
                /**
                 * Converts this KeyData_V1 to JSON.
                 * @function toJSON
                 * @memberof vereign.protobuf.qrcode_data.KeyData_V1
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                KeyData_V1.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
                return KeyData_V1;
            })();
            qrcode_data.WrapperData = (function () {
                /**
                 * Properties of a WrapperData.
                 * @memberof vereign.protobuf.qrcode_data
                 * @interface IWrapperData
                 * @property {Uint8Array|null} [data] WrapperData data
                 * @property {number|null} [version] WrapperData version
                 * @property {string|null} [className] WrapperData className
                 */
                /**
                 * Constructs a new WrapperData.
                 * @memberof vereign.protobuf.qrcode_data
                 * @classdesc Represents a WrapperData.
                 * @implements IWrapperData
                 * @constructor
                 * @param {vereign.protobuf.qrcode_data.IWrapperData=} [properties] Properties to set
                 */
                function WrapperData(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
                /**
                 * WrapperData data.
                 * @member {Uint8Array} data
                 * @memberof vereign.protobuf.qrcode_data.WrapperData
                 * @instance
                 */
                WrapperData.prototype.data = $util.newBuffer([]);
                /**
                 * WrapperData version.
                 * @member {number} version
                 * @memberof vereign.protobuf.qrcode_data.WrapperData
                 * @instance
                 */
                WrapperData.prototype.version = 0;
                /**
                 * WrapperData className.
                 * @member {string} className
                 * @memberof vereign.protobuf.qrcode_data.WrapperData
                 * @instance
                 */
                WrapperData.prototype.className = "";
                /**
                 * Creates a new WrapperData instance using the specified properties.
                 * @function create
                 * @memberof vereign.protobuf.qrcode_data.WrapperData
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IWrapperData=} [properties] Properties to set
                 * @returns {vereign.protobuf.qrcode_data.WrapperData} WrapperData instance
                 */
                WrapperData.create = function create(properties) {
                    return new WrapperData(properties);
                };
                /**
                 * Encodes the specified WrapperData message. Does not implicitly {@link vereign.protobuf.qrcode_data.WrapperData.verify|verify} messages.
                 * @function encode
                 * @memberof vereign.protobuf.qrcode_data.WrapperData
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IWrapperData} message WrapperData message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                WrapperData.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.data != null && Object.hasOwnProperty.call(message, "data"))
                        writer.uint32(/* id 1, wireType 2 =*/ 10).bytes(message.data);
                    if (message.version != null && Object.hasOwnProperty.call(message, "version"))
                        writer.uint32(/* id 2, wireType 0 =*/ 16).int32(message.version);
                    if (message.className != null && Object.hasOwnProperty.call(message, "className"))
                        writer.uint32(/* id 3, wireType 2 =*/ 26).string(message.className);
                    return writer;
                };
                /**
                 * Encodes the specified WrapperData message, length delimited. Does not implicitly {@link vereign.protobuf.qrcode_data.WrapperData.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.WrapperData
                 * @static
                 * @param {vereign.protobuf.qrcode_data.IWrapperData} message WrapperData message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                WrapperData.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
                /**
                 * Decodes a WrapperData message from the specified reader or buffer.
                 * @function decode
                 * @memberof vereign.protobuf.qrcode_data.WrapperData
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {vereign.protobuf.qrcode_data.WrapperData} WrapperData
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                WrapperData.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.vereign.protobuf.qrcode_data.WrapperData();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                            case 1:
                                message.data = reader.bytes();
                                break;
                            case 2:
                                message.version = reader.int32();
                                break;
                            case 3:
                                message.className = reader.string();
                                break;
                            default:
                                reader.skipType(tag & 7);
                                break;
                        }
                    }
                    return message;
                };
                /**
                 * Decodes a WrapperData message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof vereign.protobuf.qrcode_data.WrapperData
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {vereign.protobuf.qrcode_data.WrapperData} WrapperData
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                WrapperData.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
                /**
                 * Verifies a WrapperData message.
                 * @function verify
                 * @memberof vereign.protobuf.qrcode_data.WrapperData
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                WrapperData.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.data != null && message.hasOwnProperty("data"))
                        if (!(message.data && typeof message.data.length === "number" || $util.isString(message.data)))
                            return "data: buffer expected";
                    if (message.version != null && message.hasOwnProperty("version"))
                        if (!$util.isInteger(message.version))
                            return "version: integer expected";
                    if (message.className != null && message.hasOwnProperty("className"))
                        if (!$util.isString(message.className))
                            return "className: string expected";
                    return null;
                };
                /**
                 * Creates a WrapperData message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof vereign.protobuf.qrcode_data.WrapperData
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {vereign.protobuf.qrcode_data.WrapperData} WrapperData
                 */
                WrapperData.fromObject = function fromObject(object) {
                    if (object instanceof $root.vereign.protobuf.qrcode_data.WrapperData)
                        return object;
                    var message = new $root.vereign.protobuf.qrcode_data.WrapperData();
                    if (object.data != null)
                        if (typeof object.data === "string")
                            $util.base64.decode(object.data, message.data = $util.newBuffer($util.base64.length(object.data)), 0);
                        else if (object.data.length)
                            message.data = object.data;
                    if (object.version != null)
                        message.version = object.version | 0;
                    if (object.className != null)
                        message.className = String(object.className);
                    return message;
                };
                /**
                 * Creates a plain object from a WrapperData message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof vereign.protobuf.qrcode_data.WrapperData
                 * @static
                 * @param {vereign.protobuf.qrcode_data.WrapperData} message WrapperData
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                WrapperData.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        if (options.bytes === String)
                            object.data = "";
                        else {
                            object.data = [];
                            if (options.bytes !== Array)
                                object.data = $util.newBuffer(object.data);
                        }
                        object.version = 0;
                        object.className = "";
                    }
                    if (message.data != null && message.hasOwnProperty("data"))
                        object.data = options.bytes === String ? $util.base64.encode(message.data, 0, message.data.length) : options.bytes === Array ? Array.prototype.slice.call(message.data) : message.data;
                    if (message.version != null && message.hasOwnProperty("version"))
                        object.version = message.version;
                    if (message.className != null && message.hasOwnProperty("className"))
                        object.className = message.className;
                    return object;
                };
                /**
                 * Converts this WrapperData to JSON.
                 * @function toJSON
                 * @memberof vereign.protobuf.qrcode_data.WrapperData
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                WrapperData.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
                return WrapperData;
            })();
            return qrcode_data;
        })();
        return protobuf;
    })();
    return vereign;
})();
module.exports = $root;
